<?php
/**
 * This script will display the whole thread of messages in one flat view.
 *
 * Copyright 2003-2005 Marko Djukic <marko@oblo.com>
 *
 * $Horde: agora/messages/index.php,v 1.15 2005/01/03 14:34:47 jan Exp $
 */

@define('AGORA_BASE', dirname(__FILE__) . '/..');
require_once AGORA_BASE . '/lib/base.php';
require_once AGORA_BASE . '/lib/Messages.php';

list($forum_id, $message_id) = Agora::getAgoraId();
$params = array('forum_id' => $forum_id);

/* Set up the message object. */
$messages = &Agora_Messages::singleton($params);

/* Get requested message, if fail then back to forums list. */
$message = $messages->getMessage($message_id);
if (is_a($message, 'PEAR_Error')) {
    $notification->push(sprintf(_("Could not open the message. %s"), $message->getMessage()), 'horde.warning');
    header('Location: ' . Horde::applicationUrl('forums.php', true));
    exit;
} elseif (empty($message)) {
    $notification->push(_("Message does not exist."), 'horde.warning');
    header('Location: ' . Horde::applicationUrl('forums.php', true));
    exit;
}

/* Log views if required. */
$message->logView();

/* Get the sorting. */
$sort_by = Agora::getSortBy('thread');
$sort_dir = Agora::getSortDir('thread');

/* Get the message array and the sorted thread list. */
$threads_list = $messages->getThreads($messages->getThreadRoot($forum_id, $message_id),
                                      true, $sort_by, $sort_dir, true);

/* Set up the column headers. */
$col_headers = array(array('message_thread' => _("Thread"), 'message_subject' => _("Subject")), 'message_author' => _("Posted By"), 'message_date' => _("Date"));
$col_headers = Agora::formatColumnHeaders($col_headers, $sort_by, $sort_dir, 'thread');

/* Actions. */
$actions = array();

/* Action link to lock thread. */
if (Auth::isAdmin('agora:admin')) {
    $url = Agora::setAgoraId($forum_id, $message_id, Horde::applicationUrl('messages/lock.php'));
    $label = ($message->isLocked()) ? _("Unlock thread") : _("Lock thread");
    $actions[] = Horde::link($url, $label) . $label . '</a>';
}

/* Get the thread table. */
$threads = $messages->getThreadsUI($threads_list, $col_headers, $prefs->getValue('thread_view_bodies'));

/* Set up the main template tags. */
$main_template = &new Horde_Template();
$main_template->set('menu', Agora::getMenu('string'));
$main_template->set('notify', Util::bufferOutput(array($notification, 'notify'), array('listeners' => 'status')));
$main_template->setOption('gettext', true);
$main_template->set('actions', $actions, true);
$main_template->set('threads', $threads, true);

$title = _("Thread List");
require AGORA_TEMPLATES . '/common-header.inc';
echo $main_template->fetch(AGORA_TEMPLATES . '/messages/index.html');
require $registry->get('templates', 'horde') . '/common-footer.inc';
